import java.awt.*;
import objectdraw.*;

/*
 * A recursive data structure to represent a stack (of wood).
 *
 * Jim Teresco, CSC 252, The College of Saint Rose, Fall 2013
 * Based on similar example from Williams College CS 134.
 * 
 * $Id: Stack.java 2230 2013-10-27 02:26:10Z terescoj $
 */

public class Stack {
    private VisibleImage first;   // the wood on the top of the stack
    private Stack rest;       // the rest of the stack

    public Stack(VisibleImage someWood, Stack theRest) {
        first = someWood;
        rest = theRest;
    }

    // pre:
    // post: returns true iff the stack is empty
    public boolean isEmpty() {
        return (first == null);
    }

    // pre: the stack is not empty
    // post: the first item is removed and is returned.
    public VisibleImage removeMostRecent()  {
        VisibleImage theFirst = first;

        first = rest.getFirst();
        rest = rest.getRest();

        return theFirst;
    }

    // pre:
    // post: returns the first item; returns null if the stack is empty
    public VisibleImage getFirst() {
        return first;
    }

    // pre:
    // pre: returns a stack containing all but the first item;
    //    returns null if the stack is empty
    public Stack getRest() {
        return rest;
    }
}